VTK: vtkFixedPointRayCastImage Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkFixedPointRayCastImage Class Reference

helper class for a ray cast image More...

`#include <vtkFixedPointRayCastImage.h>`

Inheritance diagram for vtkFixedPointRayCastImage:
[legend]
Collaboration diagram for vtkFixedPointRayCastImage:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkFixedPointRayCastImage * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
unsigned short * | GetImage ()
| Get the internal storage for the image. More...
void | AllocateImage ()
| Call this method once the ImageMemorySize has been set the allocate the image. More...
void | ClearImage ()
| Clear the image to (0,0,0,0) for each pixel. More...
float | GetZBufferValue (int x, int y)
| Get the ZBuffer value corresponding to location (x,y) where (x,y) are indexing into the ImageInUse image. More...
float * | GetZBuffer ()
| Get the ZBuffer. More...
void | AllocateZBuffer ()
virtual void | SetImageViewportSize (int, int)
| Set / Get the ImageViewportSize. More...
void | SetImageViewportSize (int[2])
| Set / Get the ImageViewportSize. More...
virtual int * | GetImageViewportSize ()
| Set / Get the ImageViewportSize. More...
virtual void | GetImageViewportSize (int data[2])
| Set / Get the ImageViewportSize. More...
virtual void | SetImageMemorySize (int, int)
| Set / Get the ImageMemorySize. More...
void | SetImageMemorySize (int[2])
| Set / Get the ImageMemorySize. More...
virtual int * | GetImageMemorySize ()
| Set / Get the ImageMemorySize. More...
virtual void | GetImageMemorySize (int data[2])
| Set / Get the ImageMemorySize. More...
virtual void | SetImageInUseSize (int, int)
| Set / Get the size of the image we are actually using. More...
void | SetImageInUseSize (int[2])
| Set / Get the size of the image we are actually using. More...
virtual int * | GetImageInUseSize ()
| Set / Get the size of the image we are actually using. More...
virtual void | GetImageInUseSize (int data[2])
| Set / Get the size of the image we are actually using. More...
virtual void | SetImageOrigin (int, int)
| Set / Get the origin of the image. More...
void | SetImageOrigin (int[2])
| Set / Get the origin of the image. More...
virtual int * | GetImageOrigin ()
| Set / Get the origin of the image. More...
virtual void | GetImageOrigin (int data[2])
| Set / Get the origin of the image. More...
virtual void | SetImageSampleDistance (float)
| Set / Get the ImageSampleDistance that will be used for rendering. More...
virtual float | GetImageSampleDistance ()
| Set / Get the ImageSampleDistance that will be used for rendering. More...
virtual void | SetZBufferSize (int, int)
| Set / Get the size of the ZBuffer in pixels. More...
void | SetZBufferSize (int[2])
| Set / Get the size of the ZBuffer in pixels. More...
virtual int * | GetZBufferSize ()
| Set / Get the size of the ZBuffer in pixels. More...
virtual void | GetZBufferSize (int data[2])
| Set / Get the size of the ZBuffer in pixels. More...
virtual void | SetZBufferOrigin (int, int)
| Set / Get the origin of the ZBuffer. More...
void | SetZBufferOrigin (int[2])
| Set / Get the origin of the ZBuffer. More...
virtual int * | GetZBufferOrigin ()
| Set / Get the origin of the ZBuffer. More...
virtual void | GetZBufferOrigin (int data[2])
| Set / Get the origin of the ZBuffer. More...
virtual void | SetUseZBuffer (vtkTypeBool)
| The UseZBuffer flag indicates whether the ZBuffer is in use. More...
virtual vtkTypeBool | GetUseZBuffer ()
| The UseZBuffer flag indicates whether the ZBuffer is in use. More...
virtual void | UseZBufferOn ()
| The UseZBuffer flag indicates whether the ZBuffer is in use. More...
virtual void | UseZBufferOff ()
| The UseZBuffer flag indicates whether the ZBuffer is in use. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkFixedPointRayCastImage * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkFixedPointRayCastImage * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkFixedPointRayCastImage ()
| ~vtkFixedPointRayCastImage () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | ImageViewportSize [2]
int | ImageMemorySize [2]
int | ImageInUseSize [2]
int | ImageOrigin [2]
float | ImageSampleDistance
unsigned short * | Image
int | ZBufferSize [2]
int | ZBufferMemorySize
int | ZBufferOrigin [2]
vtkTypeBool | UseZBuffer
float * | ZBuffer
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

helper class for a ray cast image

This is a helper class for storing the ray cast image including the underlying data and the size of the image. This class is not intended to be used directly - just as an internal class in the vtkFixedPointVolumeRayCastMapper so that multiple mappers can share the same image. This class also stored the ZBuffer (if necessary due to intermixed geometry). Perhaps this class could be generalized in the future to be used for other ray cast methods other than the fixed point method.

See also
  vtkFixedPointVolumeRayCastMapper

Definition at line 28 of file vtkFixedPointRayCastImage.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkFixedPointRayCastImage::Superclass

Definition at line 32 of file vtkFixedPointRayCastImage.h.

## Constructor & Destructor Documentation

## ◆ vtkFixedPointRayCastImage()

vtkFixedPointRayCastImage::vtkFixedPointRayCastImage | ( |  | ) |
| protected

## ◆ ~vtkFixedPointRayCastImage()

vtkFixedPointRayCastImage::~vtkFixedPointRayCastImage | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkFixedPointRayCastImage* vtkFixedPointRayCastImage::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkFixedPointRayCastImage::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkFixedPointRayCastImage::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkFixedPointRayCastImage* vtkFixedPointRayCastImage::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkFixedPointRayCastImage::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkFixedPointRayCastImage* vtkFixedPointRayCastImage::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkFixedPointRayCastImage::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ GetImage()

unsigned short* vtkFixedPointRayCastImage::GetImage | ( |  | ) |
| inline

Get the internal storage for the image.

It is a pointer to unsigned short with four components (RGBA) per pixel. This memory is allocated when the AllocateImage method is called.

Definition at line 40 of file vtkFixedPointRayCastImage.h.

## ◆ SetImageViewportSize() [1/2]

virtual void vtkFixedPointRayCastImage::SetImageViewportSize | ( | int | ,
|  | int |
| ) |  |
| virtual

Set / Get the ImageViewportSize.

This is the size of the whole viewport in pixels.

## ◆ SetImageViewportSize() [2/2]

void vtkFixedPointRayCastImage::SetImageViewportSize | ( | int | [2] | ) |

Set / Get the ImageViewportSize.

This is the size of the whole viewport in pixels.

## ◆ GetImageViewportSize() [1/2]

virtual int* vtkFixedPointRayCastImage::GetImageViewportSize | ( |  | ) |
| virtual

Set / Get the ImageViewportSize.

This is the size of the whole viewport in pixels.

## ◆ GetImageViewportSize() [2/2]

virtual void vtkFixedPointRayCastImage::GetImageViewportSize | ( | int | data[2] | ) |
| virtual

Set / Get the ImageViewportSize.

This is the size of the whole viewport in pixels.

## ◆ SetImageMemorySize() [1/2]

virtual void vtkFixedPointRayCastImage::SetImageMemorySize | ( | int | ,
|  | int |
| ) |  |
| virtual

Set / Get the ImageMemorySize.

This is the size in pixels of the Image ivar. This will be a power of two in order to ensure that the texture can be rendered by graphics hardware that requires power of two textures.

## ◆ SetImageMemorySize() [2/2]

void vtkFixedPointRayCastImage::SetImageMemorySize | ( | int | [2] | ) |

Set / Get the ImageMemorySize.

This is the size in pixels of the Image ivar. This will be a power of two in order to ensure that the texture can be rendered by graphics hardware that requires power of two textures.

## ◆ GetImageMemorySize() [1/2]

virtual int* vtkFixedPointRayCastImage::GetImageMemorySize | ( |  | ) |
| virtual

Set / Get the ImageMemorySize.

This is the size in pixels of the Image ivar. This will be a power of two in order to ensure that the texture can be rendered by graphics hardware that requires power of two textures.

## ◆ GetImageMemorySize() [2/2]

virtual void vtkFixedPointRayCastImage::GetImageMemorySize | ( | int | data[2] | ) |
| virtual

Set / Get the ImageMemorySize.

This is the size in pixels of the Image ivar. This will be a power of two in order to ensure that the texture can be rendered by graphics hardware that requires power of two textures.

## ◆ SetImageInUseSize() [1/2]

virtual void vtkFixedPointRayCastImage::SetImageInUseSize | ( | int | ,
|  | int |
| ) |  |
| virtual

Set / Get the size of the image we are actually using.

As long as the memory size is big enough, but not too big, we won't bother deleting and re-allocated, we'll just continue to use the memory size we have. This size will always be equal to or less than the ImageMemorySize.

## ◆ SetImageInUseSize() [2/2]

void vtkFixedPointRayCastImage::SetImageInUseSize | ( | int | [2] | ) |

Set / Get the size of the image we are actually using.

As long as the memory size is big enough, but not too big, we won't bother deleting and re-allocated, we'll just continue to use the memory size we have. This size will always be equal to or less than the ImageMemorySize.

## ◆ GetImageInUseSize() [1/2]

virtual int* vtkFixedPointRayCastImage::GetImageInUseSize | ( |  | ) |
| virtual

Set / Get the size of the image we are actually using.

As long as the memory size is big enough, but not too big, we won't bother deleting and re-allocated, we'll just continue to use the memory size we have. This size will always be equal to or less than the ImageMemorySize.

## ◆ GetImageInUseSize() [2/2]

virtual void vtkFixedPointRayCastImage::GetImageInUseSize | ( | int | data[2] | ) |
| virtual

Set / Get the size of the image we are actually using.

As long as the memory size is big enough, but not too big, we won't bother deleting and re-allocated, we'll just continue to use the memory size we have. This size will always be equal to or less than the ImageMemorySize.

## ◆ SetImageOrigin() [1/2]

virtual void vtkFixedPointRayCastImage::SetImageOrigin | ( | int | ,
|  | int |
| ) |  |
| virtual

Set / Get the origin of the image.

This is the starting pixel within the whole viewport that our Image starts on. That is, we could be generating just a subregion of the whole viewport due to the fact that our volume occupies only a portion of the viewport. The Image pixels will start from this location.

## ◆ SetImageOrigin() [2/2]

void vtkFixedPointRayCastImage::SetImageOrigin | ( | int | [2] | ) |

Set / Get the origin of the image.

This is the starting pixel within the whole viewport that our Image starts on. That is, we could be generating just a subregion of the whole viewport due to the fact that our volume occupies only a portion of the viewport. The Image pixels will start from this location.

## ◆ GetImageOrigin() [1/2]

virtual int* vtkFixedPointRayCastImage::GetImageOrigin | ( |  | ) |
| virtual

Set / Get the origin of the image.

This is the starting pixel within the whole viewport that our Image starts on. That is, we could be generating just a subregion of the whole viewport due to the fact that our volume occupies only a portion of the viewport. The Image pixels will start from this location.

## ◆ GetImageOrigin() [2/2]

virtual void vtkFixedPointRayCastImage::GetImageOrigin | ( | int | data[2] | ) |
| virtual

Set / Get the origin of the image.

This is the starting pixel within the whole viewport that our Image starts on. That is, we could be generating just a subregion of the whole viewport due to the fact that our volume occupies only a portion of the viewport. The Image pixels will start from this location.

## ◆ SetImageSampleDistance()

virtual void vtkFixedPointRayCastImage::SetImageSampleDistance | ( | float |  | ) |
| virtual

Set / Get the ImageSampleDistance that will be used for rendering.

This is a copy of the value stored in the mapper. It is stored here for sharing between all mappers that are participating in the creation of this image.

## ◆ GetImageSampleDistance()

virtual float vtkFixedPointRayCastImage::GetImageSampleDistance | ( |  | ) |
| virtual

Set / Get the ImageSampleDistance that will be used for rendering.

This is a copy of the value stored in the mapper. It is stored here for sharing between all mappers that are participating in the creation of this image.

## ◆ AllocateImage()

void vtkFixedPointRayCastImage::AllocateImage | ( |  | ) |

Call this method once the ImageMemorySize has been set the allocate the image.

If an image already exists, it will be deleted first.

## ◆ ClearImage()

void vtkFixedPointRayCastImage::ClearImage | ( |  | ) |

Clear the image to (0,0,0,0) for each pixel.

## ◆ SetZBufferSize() [1/2]

virtual void vtkFixedPointRayCastImage::SetZBufferSize | ( | int | ,
|  | int |
| ) |  |
| virtual

Set / Get the size of the ZBuffer in pixels.

The zbuffer will be captured for the region of the screen covered by the ImageInUseSize image. However, due to subsampling, the size of the ImageInUseSize image may be smaller than this ZBuffer image which will be captured at screen resolution.

## ◆ SetZBufferSize() [2/2]

void vtkFixedPointRayCastImage::SetZBufferSize | ( | int | [2] | ) |

Set / Get the size of the ZBuffer in pixels.

The zbuffer will be captured for the region of the screen covered by the ImageInUseSize image. However, due to subsampling, the size of the ImageInUseSize image may be smaller than this ZBuffer image which will be captured at screen resolution.

## ◆ GetZBufferSize() [1/2]

virtual int* vtkFixedPointRayCastImage::GetZBufferSize | ( |  | ) |
| virtual

Set / Get the size of the ZBuffer in pixels.

The zbuffer will be captured for the region of the screen covered by the ImageInUseSize image. However, due to subsampling, the size of the ImageInUseSize image may be smaller than this ZBuffer image which will be captured at screen resolution.

## ◆ GetZBufferSize() [2/2]

virtual void vtkFixedPointRayCastImage::GetZBufferSize | ( | int | data[2] | ) |
| virtual

Set / Get the size of the ZBuffer in pixels.

The zbuffer will be captured for the region of the screen covered by the ImageInUseSize image. However, due to subsampling, the size of the ImageInUseSize image may be smaller than this ZBuffer image which will be captured at screen resolution.

## ◆ SetZBufferOrigin() [1/2]

virtual void vtkFixedPointRayCastImage::SetZBufferOrigin | ( | int | ,
|  | int |
| ) |  |
| virtual

Set / Get the origin of the ZBuffer.

This is the distance from the lower left corner of the viewport where the ZBuffer started (multiply the ImageOrigin by the ImageSampleDistance) This is the pixel location on the full resolution viewport where the ZBuffer capture will start. These values are used to convert the (x,y) pixel location within the ImageInUseSize image into a ZBuffer location.

## ◆ SetZBufferOrigin() [2/2]

void vtkFixedPointRayCastImage::SetZBufferOrigin | ( | int | [2] | ) |

Set / Get the origin of the ZBuffer.

This is the distance from the lower left corner of the viewport where the ZBuffer started (multiply the ImageOrigin by the ImageSampleDistance) This is the pixel location on the full resolution viewport where the ZBuffer capture will start. These values are used to convert the (x,y) pixel location within the ImageInUseSize image into a ZBuffer location.

## ◆ GetZBufferOrigin() [1/2]

virtual int* vtkFixedPointRayCastImage::GetZBufferOrigin | ( |  | ) |
| virtual

Set / Get the origin of the ZBuffer.

This is the distance from the lower left corner of the viewport where the ZBuffer started (multiply the ImageOrigin by the ImageSampleDistance) This is the pixel location on the full resolution viewport where the ZBuffer capture will start. These values are used to convert the (x,y) pixel location within the ImageInUseSize image into a ZBuffer location.

## ◆ GetZBufferOrigin() [2/2]

virtual void vtkFixedPointRayCastImage::GetZBufferOrigin | ( | int | data[2] | ) |
| virtual

Set / Get the origin of the ZBuffer.

This is the distance from the lower left corner of the viewport where the ZBuffer started (multiply the ImageOrigin by the ImageSampleDistance) This is the pixel location on the full resolution viewport where the ZBuffer capture will start. These values are used to convert the (x,y) pixel location within the ImageInUseSize image into a ZBuffer location.

## ◆ SetUseZBuffer()

virtual void vtkFixedPointRayCastImage::SetUseZBuffer | ( | vtkTypeBool |  | ) |
| virtual

The UseZBuffer flag indicates whether the ZBuffer is in use.

The ZBuffer is captured and used when IntermixIntersectingGeometry is on in the mapper, and when there are props that have been rendered before the current volume.

## ◆ GetUseZBuffer()

virtual vtkTypeBool vtkFixedPointRayCastImage::GetUseZBuffer | ( |  | ) |
| virtual

The UseZBuffer flag indicates whether the ZBuffer is in use.

The ZBuffer is captured and used when IntermixIntersectingGeometry is on in the mapper, and when there are props that have been rendered before the current volume.

## ◆ UseZBufferOn()

virtual void vtkFixedPointRayCastImage::UseZBufferOn | ( |  | ) |
| virtual

The UseZBuffer flag indicates whether the ZBuffer is in use.

The ZBuffer is captured and used when IntermixIntersectingGeometry is on in the mapper, and when there are props that have been rendered before the current volume.

## ◆ UseZBufferOff()

virtual void vtkFixedPointRayCastImage::UseZBufferOff | ( |  | ) |
| virtual

The UseZBuffer flag indicates whether the ZBuffer is in use.

The ZBuffer is captured and used when IntermixIntersectingGeometry is on in the mapper, and when there are props that have been rendered before the current volume.

## ◆ GetZBufferValue()

float vtkFixedPointRayCastImage::GetZBufferValue | ( | int | x,
|  | int | y
| ) |  |

Get the ZBuffer value corresponding to location (x,y) where (x,y) are indexing into the ImageInUse image.

This must be converted to the zbuffer image coordinates. Nearest neighbor value is returned. If UseZBuffer is off, then 1.0 is always returned.

## ◆ GetZBuffer()

float* vtkFixedPointRayCastImage::GetZBuffer | ( |  | ) |
| inline

Get the ZBuffer.

The size of the ZBuffer should be specific with SetZBufferSize, and AllocateZBuffer method should be called before getting the ZBuffer.

Definition at line 161 of file vtkFixedPointRayCastImage.h.

## ◆ AllocateZBuffer()

void vtkFixedPointRayCastImage::AllocateZBuffer | ( |  | ) |

## Member Data Documentation

## ◆ ImageViewportSize

int vtkFixedPointRayCastImage::ImageViewportSize[2]
| protected

Definition at line 172 of file vtkFixedPointRayCastImage.h.

## ◆ ImageMemorySize

int vtkFixedPointRayCastImage::ImageMemorySize[2]
| protected

Definition at line 178 of file vtkFixedPointRayCastImage.h.

## ◆ ImageInUseSize

int vtkFixedPointRayCastImage::ImageInUseSize[2]
| protected

Definition at line 184 of file vtkFixedPointRayCastImage.h.

## ◆ ImageOrigin

int vtkFixedPointRayCastImage::ImageOrigin[2]
| protected

Definition at line 188 of file vtkFixedPointRayCastImage.h.

## ◆ ImageSampleDistance

float vtkFixedPointRayCastImage::ImageSampleDistance
| protected

Definition at line 192 of file vtkFixedPointRayCastImage.h.

## ◆ Image

unsigned short* vtkFixedPointRayCastImage::Image
| protected

Definition at line 195 of file vtkFixedPointRayCastImage.h.

## ◆ ZBufferSize

int vtkFixedPointRayCastImage::ZBufferSize[2]
| protected

Definition at line 198 of file vtkFixedPointRayCastImage.h.

## ◆ ZBufferMemorySize

int vtkFixedPointRayCastImage::ZBufferMemorySize
| protected

Definition at line 203 of file vtkFixedPointRayCastImage.h.

## ◆ ZBufferOrigin

int vtkFixedPointRayCastImage::ZBufferOrigin[2]
| protected

Definition at line 207 of file vtkFixedPointRayCastImage.h.

## ◆ UseZBuffer

vtkTypeBool vtkFixedPointRayCastImage::UseZBuffer
| protected

Definition at line 210 of file vtkFixedPointRayCastImage.h.

## ◆ ZBuffer

float* vtkFixedPointRayCastImage::ZBuffer
| protected

Definition at line 213 of file vtkFixedPointRayCastImage.h.

The documentation for this class was generated from the following file:

- Rendering/Volume/vtkFixedPointRayCastImage.h